package cn.cecep.talroad.service.impl;

import cn.cecep.talroad.domain.MonDevOther;
import cn.cecep.talroad.mapper.MonDevOtherMapper;
import cn.cecep.talroad.service.IMonDevOtherService;
import cn.cecep.talroad.vo.MonDevGtVO;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;




/**
 * 设备数据(有组织)-其它时间 保存设备的小时以上的数据Service业务层处理
 *
 * @author szhpt
 * @date 2023-01-10*/
@Service
public class MonDevOtherServiceImpl extends ServiceImpl<MonDevOtherMapper,MonDevOther> implements IMonDevOtherService
{
    @Autowired
    private MonDevOtherMapper monDevOtherMapper;

    /**
     * 查询设备数据(有组织)-其它时间 保存设备的小时以上的数据列表
     *
     * @param monDevOther 设备数据(有组织)-其它时间 保存设备的小时以上的数据
     * @return 设备数据(有组织)-其它时间 保存设备的小时以上的数据
     */
    @Override
    public List<MonDevOther> selectMonDevOtherList(MonDevOther monDevOther)
    {
        return monDevOtherMapper.selectMonDevOtherList(monDevOther);
    }

    @Override
    public List<MonDevGtVO> getDataPage(String factoryId, List<String> deviceIds, String timeType, String startTime, String endTime, String orderField, String orderType, Page page) {
        QueryWrapper<MonDevGtVO> queryWrapper = new QueryWrapper<MonDevGtVO>()
                .eq("r.factory_id", factoryId)
                .in("r.device_id", deviceIds)
                .eq("r.time_type", timeType)
                .ge("r.data_time", startTime)
                .le("r.data_time", endTime)
                .orderBy(StringUtils.isNotEmpty(orderField), "asc".equals(orderType), orderField, "r.data_id");
        return baseMapper.getDataPage2(page, queryWrapper);
    }

}
